## orcania 1.1

=== src/Makefile ===
#
# Ulfius Framework
#
# Makefile used to build the software
#
# Copyright 2014-2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PREFIX=/usr/local
CC=gcc
CFLAGS=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS) $(JANSSONFLAG)
LIBS=-lc -ljansson
OUTPUT=liborcania.so
VERSION=1.1

ifneq (($(JANSSONFLAG)),"")
LJANSSON=-ljansson
endif

all: release

liborcania.so: memory.o orcania.o base64.o
	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) orcania.o memory.o base64.o $(LIBS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

orcania.o: orcania.h orcania.c
	$(CC) $(CFLAGS) orcania.c

memory.o: orcania.h memory.c
	$(CC) $(CFLAGS) memory.c

base64.o: orcania.h base64.c
	$(CC) $(CFLAGS) base64.c

clean:
	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*

install: all
	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
	cp orcania.h $(PREFIX)/include
	/sbin/ldconfig -r $(PREFIX)

uninstall:
	rm -f $(PREFIX)/lib/$(OUTPUT)
	rm -f $(PREFIX)/lib/$(OUTPUT).*
	rm -f $(PREFIX)/include/orcania.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: liborcania.so

release: ADDITIONALFLAGS=-O3

release: liborcania.so

=== debian/changelog ===
orcania (1.1-3) unstable; urgency=medium

  * fix strnstr issue on non-linux (Closes: #869747)
    (thanks to Pino Toscano for the patch)

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 01 Aug 2017 20:17:33 +0200

orcania (1.1-2) unstable; urgency=medium

  * update dependencies

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 20 Jul 2017 19:23:33 +0200

orcania (1.1-1) unstable; urgency=medium

  * Initial release

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 18 Jul 2017 19:32:33 +0200

=== debian/control ===
Source: orcania
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 10)
	, libjansson-dev
Standards-Version: 4.0.0
Homepage: https://github.com/babelouest/orcania
#Vcs-Git: https://anonscm.debian.org/collab-maint/oauth2-server.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/oauth2-server.git

Package: liborcania1.1
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for angharad programs
 Different functions for different purposes but that can be shared 
 between other projects
 .
 Basically these are used for other programs in the anghard project.

Package: liborcania-dev
Architecture: any
Section: libdevel
Depends: liborcania1.1 (= ${binary:Version})
	, ${misc:Depends}
	, libjansson-dev
Description: library for angharad programs, development files
 Different functions for different purposes but that can be shared 
 between other projects
 .
 Basically these are used for other programs in the anghard project.
 .
 This package contains the development files.

## orcania 1.1.1

=== Makefile ===
#
# Orcania Framework
#
# Makefile used to build all programs
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

LIBORCANIA_LOCATION=./src
TESTS_LOCATION=./test

all: liborcania.so

debug:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) debug

clean:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean

run_test:
	cd $(TESTS_LOCATION) && $(MAKE) test

install:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) install

uninstall:
	cd $(LIBORCANIA_LOCATION) && $(MAKE) uninstall

liborcania.so:
	cd $(LIBORCANIA_LOCATION) && $(MAKE)

=== src/Makefile ===
--- 
+++ 
@@ -21,19 +21,23 @@
 PREFIX=/usr/local
 CC=gcc
 CFLAGS=-c -fPIC -Wall -D_REENTRANT $(ADDITIONALFLAGS) $(JANSSONFLAG)
-LIBS=-lc -ljansson
 OUTPUT=liborcania.so
-VERSION=1.1
+VERSION=1.1.1
 
-ifneq (($(JANSSONFLAG)),"")
+ifndef JANSSONFLAG
 LJANSSON=-ljansson
 endif
+
+LIBS=-lc $(LJANSSON)
 
 all: release
 
 liborcania.so: memory.o orcania.o base64.o
 	$(CC) -shared -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) orcania.o memory.o base64.o $(LIBS)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
+
+liborcania.a: memory.o orcania.o base64.o
+	ar rcs liborcania.a memory.o orcania.o base64.o
 
 orcania.o: orcania.h orcania.c
 	$(CC) $(CFLAGS) orcania.c
@@ -45,15 +49,19 @@
 	$(CC) $(CFLAGS) base64.c
 
 clean:
-	rm -f *.o *.so $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
 
 install: all
 	cp $(OUTPUT).$(VERSION) $(PREFIX)/lib
 	cp orcania.h $(PREFIX)/include
-	/sbin/ldconfig -r $(PREFIX)
+	-ldconfig
+
+static-install: static
+	cp liborcania.a $(PREFIX)/lib
+	cp orcania.h $(PREFIX)/include
 
 uninstall:
-	rm -f $(PREFIX)/lib/$(OUTPUT)
+	rm -f $(PREFIX)/lib/$(OUTPUT) $(PREFIX)/lib/liborcania.a
 	rm -f $(PREFIX)/lib/$(OUTPUT).*
 	rm -f $(PREFIX)/include/orcania.h
 
@@ -64,3 +72,11 @@
 release: ADDITIONALFLAGS=-O3
 
 release: liborcania.so
+
+static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0
+
+static-debug: liborcania.a
+
+static: ADDITIONALFLAGS=-O3
+
+static: liborcania.a

=== test/Makefile ===
#
# Orcania library
#
# Makefile used to build the tests
#
# Copyright 2017 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

CC=gcc
CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
ORCANIA_LOCATION=../src
LIBS=-lc -lorcania -ljansson -lcheck -lpthread -lm -lrt -lsubunit -L$(ORCANIA_LOCATION)

all: test

clean:
	rm -f *.o str_test split_test memory_test jansson_test valgrind.txt

liborcania.so:
	cd $(ORCANIA_LOCATION) && $(MAKE) debug

str_test: str_test.c
	$(CC) $(CFLAGS) str_test.c -o str_test $(LIBS)

test_str_test: liborcania.so str_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./str_test

split_test: split_test.c
	$(CC) $(CFLAGS) split_test.c -o split_test $(LIBS)

test_split_test: liborcania.so split_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./split_test

memory_test: memory_test.c
	$(CC) $(CFLAGS) memory_test.c -o memory_test $(LIBS)

test_memory_test: liborcania.so memory_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./memory_test

jansson_test: jansson_test.c
	$(CC) $(CFLAGS) jansson_test.c -o jansson_test $(LIBS)

test_jansson_test: liborcania.so jansson_test
	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./jansson_test

test: test_str_test test_split_test test_jansson_test

=== debian/changelog ===
orcania (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use dh11

 -- Thorsten Alteholz <debian@alteholz.de>  Thu, 25 Jan 2018 19:44:08 +0100

orcania (1.1-4) unstable; urgency=medium

  * debian/control: bump standard to 4.1.0 (no changes)
  * debian/control: add VCS URLs

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 02 Sep 2017 17:26:33 +0200

=== debian/control ===
Source: orcania
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper (>= 11)
	, libjansson-dev
Standards-Version: 4.1.3
Homepage: https://github.com/babelouest/orcania
Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/orcania.git
Vcs-Git: https://anonscm.debian.org/git/debian-iot/orcania.git

Package: liborcania1.1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for angharad programs
 Different functions for different purposes but that can be shared
 between other projects
 .
 Basically these are used for other programs in the anghard project.

Package: liborcania-dev
Architecture: any
Section: libdevel
Depends: liborcania1.1 (= ${binary:Version})
	, ${misc:Depends}
	, libjansson-dev
Description: library for angharad programs, development files
 Different functions for different purposes but that can be shared
 between other projects
 .
 Basically these are used for other programs in the anghard project.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_install:
	echo "dh_auto_install"

## orcania 1.2.3

=== CMakeLists.txt ===
#
# Orcania library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(orcania C)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")

# library info

set(PROJECT_DESCRIPTION "Potluck with different functions for different purposes that can be shared among programs")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/orcania/issues")

set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "2")
set(LIBRARY_VERSION_PATCH "3")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/orcania.h # allow many IDEs to find and edit it
        ${SRC_DIR}/base64.c
        ${SRC_DIR}/memory.c
        ${SRC_DIR}/orcania.c)

# dependencies

option(WITH_JANSSON "Use jansson library" ON)

if (WITH_JANSSON)
    include(FindJansson)
    set(JANSSON_MIN_VERSION 2.4)
    find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
    if (JANSSON_FOUND)
        set(LIBS ${JANSSON_LIBRARIES})
    endif ()
else ()
    add_definitions(-DU_DISABLE_JANSSON)
endif ()

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(orcania_static STATIC ${LIB_SRC})
    target_compile_definitions(orcania_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(orcania_static PROPERTIES
            OUTPUT_NAME liborcania)
endif ()

# shared library

add_library(orcania SHARED ${LIB_SRC})
set_target_properties(orcania PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER ${INC_DIR}/orcania.h
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")
if (WIN32)
    set_target_properties(orcania PROPERTIES SUFFIX "-${LIBRARY_VERSION_MAJOR}.dll")
endif ()
target_link_libraries(orcania ${LIBS})

# tests

option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)

if (BUILD_TESTING)
    include(FindCheck)
    find_package(Check)
    if (CHECK_FOUND)
        if (NOT WIN32)
            include(FindSubunit)
            find_package(Subunit REQUIRED)
        endif ()

        enable_testing()

        set(CMAKE_CTEST_COMMAND ctest -V)

        set(TST_DIR ${CMAKE_CURRENT_SOURCE_DIR}/test)
        set(LIBS orcania ${LIBS} ${CHECK_LIBRARIES})
        if (NOT WIN32)
            find_package(Threads REQUIRED)
            set(LIBS ${LIBS} ${SUBUNIT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} m rt)
        endif ()

        set(TESTS
                str_test
                split_test
                memory_test)
        if (WITH_JANSSON)
            set(TESTS ${TESTS} jansson_test)
        endif ()

        configure_file(
                "${CMAKE_MODULE_PATH}/CTestCustom.cmake.in"
                "${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake"
                @ONLY)

        foreach (t ${TESTS})
            add_executable(${t} EXCLUDE_FROM_ALL ${TST_DIR}/${t}.c)
            target_include_directories(${t} PUBLIC ${TST_DIR})
            target_link_libraries(${t} PUBLIC ${LIBS})
            add_test(NAME ${t}
                    WORKING_DIRECTORY ${TST_DIR}
                    COMMAND ${t})
        endforeach ()
    endif ()
endif ()

# install target

option(INSTALL_HEADER "Install the header files" ON) # Install orcania.h or not

configure_file(liborcania.pc.in liborcania.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/liborcania.pc
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)

set(TARGETS orcania)
if (BUILD_STATIC)
    set(TARGETS ${TARGETS} orcania_static)
endif ()

if (INSTALL_HEADER)
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
else ()
    install(TARGETS ${TARGETS}
            RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif ()

# uninstall target

if (NOT TARGET uninstall)
    configure_file(
            "${CMAKE_MODULE_PATH}/CMakeUninstall.cmake.in"
            "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
            IMMEDIATE @ONLY)
    add_custom_target(uninstall
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif ()

# packaging

set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (INSTALL_HEADER)
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}-dev_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
else ()
    set(PACKAGE_FILE_NAME
            "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
endif ()
set(PACKAGE_IGNORED_FILES
        "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")

set(CPACK_GENERATOR "TGZ;DEB")

set(CPACK_DEBIAN_PACKAGE_NAME "liborcania")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/orcania")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), libcurl3-gnutls (>= 7.16.2), libjansson4 (>= 2.1)")
set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
set(CPACK_SOURCE_IGNORE_FILES ${PACKAGE_IGNORED_FILES})

include(CPack)

add_custom_target(dist_o
        COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

=== src/Makefile ===
#
# Orcania Library
#
# Makefile used to build the software
#
# Copyright 2014-2018 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -fPIC -Wall -Werror -Wextra -D_REENTRANT $(ADDITIONALFLAGS) $(JANSSONFLAG)
OUTPUT=liborcania.so
VERSION=1.2.3

ifndef JANSSONFLAG
LJANSSON=-ljansson
endif

LIBS=-lc $(LJANSSON)

all: release

liborcania.so: memory.o orcania.o base64.o
	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) orcania.o memory.o base64.o $(LIBS) $(LDFLAGS)
	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)

liborcania.a: memory.o orcania.o base64.o
	ar rcs liborcania.a memory.o orcania.o base64.o

%.o: %.c ../include/orcania.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*

install: all
	install $(OUTPUT).$(VERSION) $(DESTDIR)/lib
	install ../include/orcania.h $(DESTDIR)/include
	-ldconfig

static-install: static
	install liborcania.a $(DESTDIR)/lib
	install ../include/orcania.h $(DESTDIR)/include

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/liborcania.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/orcania.h

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: liborcania.so

release: ADDITIONALFLAGS=-O3

release: liborcania.so

static-debug: ADDITIONALFLAGS=-DDEBUG -g -O0

static-debug: liborcania.a

static: ADDITIONALFLAGS=-O3

static: liborcania.a

=== test/Makefile ===
--- 
+++ 
@@ -56,4 +56,4 @@
 test_jansson_test: liborcania.so jansson_test
 	-LD_LIBRARY_PATH=$(ORCANIA_LOCATION):${LD_LIBRARY_PATH} ./jansson_test
 
-test: test_str_test test_split_test test_jansson_test
+test: test_str_test test_split_test test_jansson_test test_memory_test

=== debian/changelog ===
orcania (1.2.3-1) unstable; urgency=medium

  * New upstream release
  * debian/rules: use cmake as buildsystem
  * debian/control: add cmake as dependency

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 15 Apr 2018 19:05:44 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,18 @@
 Source: orcania
 Section: devel
 Priority: optional
-Maintainer: Thorsten Alteholz <debian@alteholz.de>
+Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
+Uploaders: Thorsten Alteholz <debian@alteholz.de>
+          , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
 	, libjansson-dev
+	, cmake
 Standards-Version: 4.1.3
 Homepage: https://github.com/babelouest/orcania
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-iot/orcania.git
-Vcs-Git: https://anonscm.debian.org/git/debian-iot/orcania.git
+Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
+Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
 
-Package: liborcania1.1
+Package: liborcania1.2
 Architecture: any
 Section: libs
 Pre-Depends: ${misc:Pre-Depends}
@@ -23,7 +26,7 @@
 Package: liborcania-dev
 Architecture: any
 Section: libdevel
-Depends: liborcania1.1 (= ${binary:Version})
+Depends: liborcania1.2 (= ${binary:Version})
 	, ${misc:Depends}
 	, libjansson-dev
 Description: library for angharad programs, development files

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,10 @@
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake --builddirectory=build
 
 override_dh_auto_install:
 	echo "dh_auto_install"
+
+override_dh_auto_configure:
+	dh_auto_configure -- $(ARGS) --no-warn-unused-cli

## orcania 1.2.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,11 +24,13 @@
 # library info
 
 set(PROJECT_DESCRIPTION "Potluck with different functions for different purposes that can be shared among programs")
+set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/orcania/")
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/orcania/issues")
-
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "2")
-set(LIBRARY_VERSION_PATCH "3")
+set(LIBRARY_VERSION_PATCH "9")
+
+set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
 
@@ -66,6 +68,13 @@
         ${SRC_DIR}/base64.c
         ${SRC_DIR}/memory.c
         ${SRC_DIR}/orcania.c)
+
+option(WITH_STRSTR "Use inline implementation of strstr" OFF)
+if (WITH_STRSTR)
+    set(STRSTR ON)
+else ()
+    set(STRSTR OFF)
+endif ()
 
 # dependencies
 
@@ -77,10 +86,26 @@
     find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
     if (JANSSON_FOUND)
         set(LIBS ${JANSSON_LIBRARIES})
+        include_directories(${JANSSON_INCLUDE_DIRS})
+        set(DISABLE_JANSSON OFF)
     endif ()
 else ()
     add_definitions(-DU_DISABLE_JANSSON)
-endif ()
+    set(DISABLE_JANSSON ON)
+endif ()
+
+if (WITH_JANSSON)
+  set(PKGCONF_REQ "")
+  set(PKGCONF_REQ_PRIVATE "jansson >= 2.1")
+else ()
+  set(PKGCONF_REQ "")
+  set(PKGCONF_REQ_PRIVATE "")
+endif ()
+
+# build orcania-cfg.h file
+configure_file(${INC_DIR}/orcania-cfg.h.in ${PROJECT_BINARY_DIR}/orcania-cfg.h)
+set (CMAKE_EXTRA_INCLUDE_FILES ${PROJECT_BINARY_DIR})
+include_directories(${PROJECT_BINARY_DIR})
 
 # static library
 
@@ -90,7 +115,7 @@
     add_library(orcania_static STATIC ${LIB_SRC})
     target_compile_definitions(orcania_static PUBLIC -DO_STATIC_LIBRARY)
     set_target_properties(orcania_static PROPERTIES
-            OUTPUT_NAME liborcania)
+            OUTPUT_NAME orcania)
 endif ()
 
 # shared library
@@ -98,7 +123,7 @@
 add_library(orcania SHARED ${LIB_SRC})
 set_target_properties(orcania PROPERTIES
         COMPILE_OPTIONS -Wextra
-        PUBLIC_HEADER ${INC_DIR}/orcania.h
+        PUBLIC_HEADER "${INC_DIR}/orcania.h;${PROJECT_BINARY_DIR}/orcania-cfg.h"
         VERSION "${LIBRARY_VERSION}"
         SOVERSION "${LIBRARY_SOVERSION}")
 if (WIN32)
@@ -108,9 +133,9 @@
 
 # tests
 
-option(BUILD_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
-
-if (BUILD_TESTING)
+option(BUILD_ORCANIA_TESTING "Build the testing tree." OFF) # because we don not use include(CTest)
+
+if (BUILD_ORCANIA_TESTING)
     include(FindCheck)
     find_package(Check)
     if (CHECK_FOUND)
@@ -161,7 +186,7 @@
 configure_file(liborcania.pc.in liborcania.pc @ONLY)
 
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/liborcania.pc
-        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
 set(TARGETS orcania)
 if (BUILD_STATIC)
@@ -208,13 +233,28 @@
 set(PACKAGE_IGNORED_FILES
         "${CMAKE_CURRENT_BINARY_DIR}/;/.git/;.gitignore;~$;${CPACK_SOURCE_IGNORE_FILES}")
 
+set(CPACK_PACKAGE_NAME "liborcania")
+set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Potluck for C programs")
 set(CPACK_GENERATOR "TGZ;DEB")
-
-set(CPACK_DEBIAN_PACKAGE_NAME "liborcania")
+set(CPACK_PACKAGE_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${LIBRARY_VERSION_PATCH})
+
+option(BUILD_RPM "Build a RPM for your system" OFF)
+if (BUILD_RPM)
+  set(CPACK_GENERATOR "TGZ;DEB;RPM")
+  set(CPACK_RPM_PACKAGE_LICENSE "LGPL")
+  set(CPACK_RPM_PACKAGE_URL "http://babelouest.github.io/orcania/")
+endif ()
+
 set(CPACK_DEBIAN_PACKAGE_MAINTAINER "mail@babelouest.org")
 set(CPACK_DEBIAN_PACKAGE_DESCRIPTION ${PROJECT_DESCRIPTION})
 set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/babelouest/orcania")
-set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4), libcurl3-gnutls (>= 7.16.2), libjansson4 (>= 2.1)")
+set(CPACK_DEBIAN_PACKAGE_DEPENDS "libc6 (>= 2.4)")
+if (WITH_JANSSON)
+  set(CPACK_DEBIAN_PACKAGE_DEPENDS "${CPACK_DEBIAN_PACKAGE_DEPENDS}, libjansson4 (>= 2.1)")
+endif ()
+set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
 set(CPACK_PACKAGE_FILE_NAME ${PACKAGE_FILE_NAME})
 
 set(CPACK_SOURCE_GENERATOR "TGZ")
@@ -225,3 +265,10 @@
 
 add_custom_target(dist_o
         COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
+
+message(STATUS "Jansson library support: ${WITH_JANSSON}")
+message(STATUS "Force inline implementation of strstr: ${WITH_STRSTR}")
+message(STATUS "Build static library: ${BUILD_STATIC}")
+message(STATUS "Build testing tree: ${BUILD_ULFIUS_TESTING}")
+message(STATUS "Install the header files: ${INSTALL_HEADER}")
+message(STATUS "Build RPM package: ${BUILD_RPM}")

=== Makefile ===
--- 
+++ 
@@ -34,5 +34,5 @@
 uninstall:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE) uninstall
 
-liborcania.so:
+release:
 	cd $(LIBORCANIA_LOCATION) && $(MAKE)

=== src/Makefile ===
--- 
+++ 
@@ -19,45 +19,79 @@
 # License along with this library.	If not, see <http://www.gnu.org/licenses/>.
 #
 DESTDIR=/usr/local
+ORCANIA_INCLUDE=../include
+CONFIG_TEMPLATE=$(ORCANIA_INCLUDE)/orcania-cfg.h.in
+CONFIG_FILE=$(ORCANIA_INCLUDE)/orcania-cfg.h
 CC=gcc
-CFLAGS+=-c -fPIC -Wall -Werror -Wextra -D_REENTRANT $(ADDITIONALFLAGS) $(JANSSONFLAG)
+CFLAGS+=-c -fPIC -Wall -Werror -Wextra -I$(ORCANIA_INCLUDE) -D_REENTRANT $(ADDITIONALFLAGS) $(CPPFLAGS)
 OUTPUT=liborcania.so
-VERSION=1.2.3
+VERSION=1.2.9
+OBJECTS=orcania.o memory.o base64.o
+LIBS=-lc
 
 ifndef JANSSONFLAG
-LJANSSON=-ljansson
+DISABLE_JANSSON=0
+LIBS+= -ljansson
+else
+DISABLE_JANSSON=1
 endif
 
-LIBS=-lc $(LJANSSON)
+ifdef STRSTRFLAG
+STRSTR=1
+else
+STRSTR=0
+endif
 
 all: release
 
-liborcania.so: memory.o orcania.o base64.o
-	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) orcania.o memory.o base64.o $(LIBS) $(LDFLAGS)
+$(CONFIG_FILE):
+	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
+	@echo Config file $(CONFIG_FILE) generated
+	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION)/g' $(CONFIG_FILE)        
+	@if [ "$(DISABLE_JANSSON)" = "1" ]; then \
+		sed -i -e 's/\#cmakedefine DISABLE_JANSSON/\#define U_DISABLE_JANSSON/g' $(CONFIG_FILE); \
+		echo "JANSSON SUPPORT         DISABLED"; \
+	else \
+		sed -i -e 's/\#cmakedefine DISABLE_JANSSON/\/* #undef U_DISABLE_JANSSON *\//g' $(CONFIG_FILE); \
+		echo "JANSSON SUPPORT         ENABLED"; \
+	fi
+	@if [ "$(STRSTR)" = "1" ]; then \
+		sed -i -e 's/\#cmakedefine STRSTR/\#define O_STRSTR/g' $(CONFIG_FILE); \
+		echo "FORCE IMPLEMENT STRSTR  ENABLED"; \
+	else \
+		sed -i -e 's/\#cmakedefine STRSTR/\/* #undef O_STRSTR *\//g' $(CONFIG_FILE); \
+		echo "FORCE IMPLEMENT STRSTR  DISABLED"; \
+	fi
+
+liborcania.so: $(OBJECTS)
+	$(CC) -shared -fPIC -Wl,-soname,$(OUTPUT) -o $(OUTPUT).$(VERSION) $(OBJECTS) $(LIBS) $(LDFLAGS)
 	ln -sf $(OUTPUT).$(VERSION) $(OUTPUT)
 
-liborcania.a: memory.o orcania.o base64.o
-	ar rcs liborcania.a memory.o orcania.o base64.o
+liborcania.a: $(OBJECTS)
+	ar rcs liborcania.a $(OBJECTS)
 
-%.o: %.c ../include/orcania.h
+%.o: %.c $(CONFIG_FILE) ../include/orcania.h
 	$(CC) $(CFLAGS) $(CPPFLAGS) $<
 
 clean:
-	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).*
+	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE)
 
 install: all
 	install $(OUTPUT).$(VERSION) $(DESTDIR)/lib
-	install ../include/orcania.h $(DESTDIR)/include
+	install -m644 ../include/orcania.h $(DESTDIR)/include
+	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
 	-ldconfig
 
 static-install: static
 	install liborcania.a $(DESTDIR)/lib
-	install ../include/orcania.h $(DESTDIR)/include
+	install -m644 ../include/orcania.h $(DESTDIR)/include
+	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
 
 uninstall:
 	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/liborcania.a
 	rm -f $(DESTDIR)/lib/$(OUTPUT).*
 	rm -f $(DESTDIR)/include/orcania.h
+	rm -f $(DESTDIR)/include/orcania-cfg.h
 
 debug: ADDITIONALFLAGS=-DDEBUG -g -O0

=== test/Makefile ===
--- 
+++ 
@@ -20,8 +20,9 @@
 #
 
 CC=gcc
-CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0
+CFLAGS=-Wall -D_REENTRANT -DDEBUG -g -O0 -I$(INCLUDE_LOCATION)
 ORCANIA_LOCATION=../src
+INCLUDE_LOCATION=../include
 LIBS=-lc -lorcania -ljansson -lcheck -lpthread -lm -lrt -lsubunit -L$(ORCANIA_LOCATION)
 
 all: test

=== debian/changelog ===
orcania (1.2.9-5) unstable; urgency=medium

  * debian/tests/control: Fix autopkgtest dependencies

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 04 Jan 2019 11:53:23 -0500

orcania (1.2.9-4) unstable; urgency=medium

  * debian/tests/control: Fix autopkgtest dependencies
  * debian/control: update Standards-Version to current 4.3.0 (no change)
  * debian/rules: clarify dh_auto_configure to explicitly declare options
                  build tests from cmake instead of Makefile

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 03 Jan 2019 19:21:04 -0500

orcania (1.2.9-3) unstable; urgency=medium

  * debian/*install: Add pkg-config file
  * debian/*install: multiarchify files

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 16 Dec 2018 12:58:21 -0500

orcania (1.2.9-2) unstable; urgency=medium

  * Fix liborcania-dev header install

 -- Nicolas Mora <nicolas@babelouest.org>  Sat, 15 Dec 2018 09:01:42 -0500

orcania (1.2.9-1) unstable; urgency=medium

  * New upstream release
  * Add autopkgtest suite
  * Add unit tests on build

 -- Nicolas Mora <nicolas@babelouest.org>  Wed, 12 Dec 2018 11:59:51 -0500

orcania (1.2.6-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 12 Oct 2018 18:27:04 -0400

orcania (1.2.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 23 Sep 2018 09:19:32 -0400

orcania (1.2.3-5) unstable; urgency=medium

  * debian/copyright: fix wildcard-matches-nothing-in-dep5-copyright

 -- Nicolas Mora <nicolas@babelouest.org>  Fri, 27 Apr 2018 07:25:30 -0400

orcania (1.2.3-4) unstable; urgency=medium

  * debian/copyright: remove unused patch

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 24 Apr 2018 12:19:46 -0400

orcania (1.2.3-3) unstable; urgency=medium

  * debian/copyright: fix lintian warnings

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 24 Apr 2018 11:57:11 -0400

orcania (1.2.3-2) unstable; urgency=medium

  * debian/copyright: add cmake scripts

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 22 Apr 2018 14:07:03 -0400

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,12 @@
 Uploaders: Thorsten Alteholz <debian@alteholz.de>
           , Nicolas Mora <nicolas@babelouest.org>
 Build-Depends: debhelper (>= 11)
+	, autopkgtest (>= 5.6~)
+	, dh-exec
 	, libjansson-dev
 	, cmake
-Standards-Version: 4.1.3
+	, check
+Standards-Version: 4.3.0
 Homepage: https://github.com/babelouest/orcania
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/orcania.git

=== debian/rules ===
--- 
+++ 
@@ -16,4 +16,7 @@
 	echo "dh_auto_install"
 
 override_dh_auto_configure:
-	dh_auto_configure -- $(ARGS) --no-warn-unused-cli
+	dh_auto_configure -- $(ARGS) -DBUILD_ORCANIA_TESTING=on\
+                                     -DINSTALL_HEADER=on\
+                                     -DWITH_JANSSON=on\
+                                     --no-warn-unused-cli

=== debian/tests/control ===
Tests: unit-test
Depends: @, gcc, libc-dev, check
